# http://guides.rubygems.org/make-your-own-gem/

class Taggr
  def self.tag(str)
  	# Scan our string for matches of the following regex: \{{2}[^\s]+\}{2}
  	regex   = /\{{2}[^\s]+\}{2}/
  	matches = str.scan(regex)

    objects = Hash.new

  	# Iterate through each match
  	matches.each do |tag|
  		tag = tag.to_s
  		tag.gsub! "{", "" # Remove instaces of {
  		tag.gsub! "}", "" # Remove instances of }
  		parts = tag.split('.') # Separate the class name and ID number

  		begin
	  		temp = parts[0].classify.constantize.find(parts[1]) # Fetch the object we've tagged

        # Add the object we tagged to our hash
        if objects[parts[0]].present?
          objects[parts[0]][parts[1]] = temp
        else
          objects[parts[0]] = { parts[1] => temp }
        end
	  	rescue
        # Unable to fetch object, let's log it in the debugger
	  		Rails.logger.debug "Taggr: was unable to fetch object #{parts[0]}.#{parts[1]}"
	  	end
  	end

    # Build the final return value
    ret_val = Hash.new
    ret_val["orig_post"] = str
    ret_val["tags"]      = objects

    return ret_val
  end
end